
%global commit 62358ba2123abd17fccf2a108a301d4b52c01a7c
%global shortcommit 62358ba
%global soname 1

Summary:    The password hash Argon2, winner of PHC
Name:       argon2
Version:    20190702
Release:    3%{?dist}
License:    Public Domain or ASL 2.0
URL:        https://github.com/P-H-C/phc-winner-argon2
Source0:    %{url}/archive/%{commit}/phc-winner-argon2-%{version}-%{shortcommit}.tar.gz

BuildRequires: gcc make
Requires:      libargon2 = %{version}-%{release}

%description
Argon2 is a password-hashing function that summarizes the state of the art
in the design of memory-hard functions and can be used to hash passwords
for credential storage, key derivation, or other applications.


%package -n libargon2
Summary:  The password-hashing library

%description -n libargon2
Argon2 is a password-hashing function that summarizes the state of the art
in the design of memory-hard functions and can be used to hash passwords
for credential storage, key derivation, or other applications.


%package -n libargon2-devel
Summary:  Development files for libargon2
Requires: libargon2 = %{version}-%{release}

%description -n libargon2-devel
The libargon2-devel package contains libraries and header files for
developing applications that use libargon2.


%prep
%autosetup -n phc-winner-argon2-%{commit}

if ! grep -q 'ABI_VERSION = %{soname}' Makefile; then
  : soname have changed
  grep soname Makefile
  exit 1
fi

sed -e 's:lib/@HOST_MULTIARCH@:%{_lib}:;s/@UPSTREAM_VER@/%{version}/' -i libargon2.pc.in


%build
sed -e '/^CFLAGS/s:^CFLAGS:LDFLAGS=%{build_ldflags}\nCFLAGS:' \
    -e 's:-O3 -Wall:%{optflags}:' \
    -e '/^LIBRARY_REL/s:lib:%{_lib}:' \
    -e 's:-march=\$(OPTTARGET) :${CFLAGS} :' \
    -e 's:CFLAGS += -march=\$(OPTTARGET)::' \
    -i Makefile

make -j1 PREFIX=%{_prefix}


%install
%make_install PREFIX=%{_prefix} LIBRARY_REL=%{_lib}
rm %{buildroot}%{_libdir}/libargon2.a
install -Dpm 644 libargon2.pc %{buildroot}%{_libdir}/pkgconfig/libargon2.pc

chmod -x %{buildroot}%{_includedir}/%{name}.h
chmod +x %{buildroot}%{_libdir}/libargon2.so.%{soname}


%check
make test

%files
%{_bindir}/%{name}

%files -n libargon2
%license LICENSE
%{_libdir}/libargon2.so.%{soname}


%files -n libargon2-devel
%doc *md
%{_includedir}/%{name}.h
%{_libdir}/libargon2.so
%{_libdir}/pkgconfig/libargon2.pc


%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20190702-3
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 20190702-2
- Rebuilt for OpenCloudOS Stream 23.05

* Wed Apr 19 2023 Miaojun Dong <zoedong@tencent.com> - 20190702-1
- initial build
